v7.3.0

Combining multiple Bryntum products

Thin packages overview

Bryntum products share the same data model and can be combined to provide different views of the underlying data.

When combining multiple Bryntum products in a single application using JavaScript, you should use thin npm packages. The main difference between thin packages and regular packages is that thin only contain product specific code and styling, while regular contain code and styling for all underlying products (for example Scheduler includes Scheduler + Grid + Core). Thin packages are also valid for building a single product application.

It is not possible to import several regular (non-thin) Bryntum npm packages like @bryntum/grid and @bryntum/calendar in one application. Doing this will lead to a runtime console error:
The Bryntum Calendar bundle was loaded multiple times by the application.
Do not mix regular (e.g., @bryntum/calendar) and thin (e.g., @bryntum/calendar-thin) packages in the same project. If using thin packages, remove regular ones and follow this guide to install all required dependencies.

Thin packages list

Bryntum's npm repository contains thin packages for combining multiple Bryntum products in one application.

Thin limited trial library packages:

Package Purpose
@bryntum/core-thin-trial Bryntum Core data and UI trial components package
@bryntum/grid-thin-trial Bryntum Grid trial components package
@bryntum/scheduler-thin-trial Bryntum Scheduler trial components package
@bryntum/schedulerpro-thin-trial Bryntum Scheduler Pro trial components package
@bryntum/gantt-thin-trial Bryntum Gantt trial components package
@bryntum/calendar-thin-trial Bryntum Calendar trial components package
@bryntum/taskboard-thin-trial Bryntum TaskBoard trial components package
@bryntum/engine-thin-trial Bryntum Scheduling engine trial components package
To use framework wrappers, trial packages listed above require aliasing the @bryntum/*-thin-trial package as @bryntum/*-thin during installation, as shown below. Once installed, the provided app code samples can be used without modification

Example for @bryntum/calendar-thin-trial package:

npm install @bryntum/calendar-thin@npm:@bryntum/calendar-thin-trial@7.3.0

Alternatively, you can directly add entries to the "dependencies" section of the package.json project file as follows:

"dependencies": {
  "@bryntum/calendar-thin": "npm:@bryntum/calendar-thin-trial@7.3.0",
}

Thin licensed library packages:

Package Purpose
@bryntum/core-thin Bryntum Core data and UI components package
@bryntum/grid-thin Bryntum Grid components package
@bryntum/scheduler-thin Bryntum Scheduler components package
@bryntum/schedulerpro-thin Bryntum Scheduler Pro components package
@bryntum/gantt-thin Bryntum Gantt components package
@bryntum/calendar-thin Bryntum Calendar components package
@bryntum/taskboard-thin Bryntum TaskBoard components package
@bryntum/engine-thin Bryntum Scheduling engine components package

Package dependencies

Each package contains code related to the specific product only and requires installing dependency packages for all underlying products. This is not done automatically to give you full control over the installed packages.

List of required dependencies used in package.json for JavaScript application:

GridSchedulerScheduler ProGanttCalendarTaskBoard
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0"
  }
}
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0"
  }
}
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/schedulerpro-thin": "7.3.0"
  }
}
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/gantt-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/schedulerpro-thin": "7.3.0"
  }
}
{
  "dependencies": {
    "@bryntum/calendar-thin": "7.3.0",
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0"
  }
}
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/taskboard-thin": "7.3.0"
  }
}

Product styling

List of required styles for JavaScript application style.css/scss:

GridSchedulerScheduler ProGanttCalendarTaskBoard
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/schedulerpro-thin/schedulerpro.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/schedulerpro-thin/schedulerpro.css';
@import '@bryntum/gantt-thin/gantt.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/calendar-thin/calendar.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/taskboard-thin/taskboard.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';

Product template

Example of configuring product template for JavaScript application main.js:

This guide assumes that you're using Vite to set up your project. Otherwise, to render the styles correctly, you must have a div container with id="app" in your index.html.
GridSchedulerScheduler ProGanttCalendarTaskBoard
import { Grid } from '@bryntum/grid-thin';
import './style.css';

const grid = new Grid({
    appendTo : 'app',
    columns  : [
        { field : 'name', text : 'Name', width : 200 },
        { field : 'city', text : 'City', flex : 1 }
    ],
    data : [
        { name : 'Dan Stevenson', city : 'Los Angeles' },
        { name : 'Talisha Babin', city : 'Paris' }
    ]
});
import { Scheduler } from '@bryntum/scheduler-thin';
import './style.css';

const scheduler = new Scheduler({
    appendTo  : 'app',
    startDate : new Date(2022, 0, 1),
    endDate   : new Date(2022, 0, 10),
    columns   : [
        { text : 'Name', field : 'name', width : 160 }
    ],
    resources : [
        { id : 1, name : 'Dan Stevenson' },
        { id : 2, name : 'Talisha Babin' }
    ],
    events : [
        { resourceId : 1, startDate : '2022-01-01', endDate : '2022-01-10' },
        { resourceId : 2, startDate : '2022-01-02', endDate : '2022-01-09' }
    ]
});
import { SchedulerPro } from '@bryntum/schedulerpro-thin';
import './style.css';

const schedulerPro = new SchedulerPro({
    appendTo  : 'app',
    startDate : new Date(2022, 0, 1),
    endDate   : new Date(2022, 0, 10),
    columns   : [
        { text : 'Name', field : 'name', width : 160 }
    ],
    project : {

        resources : [
            { id : 1, name : 'Dan Stevenson' },
            { id : 2, name : 'Talisha Babin' }
        ],

        events : [
            { id : 1, startDate : '2022-01-01', duration : 3, durationUnit : 'd', name : 'Event 1' },
            { id : 2, duration : 4, durationUnit : 'd', name : 'Event 2' }
        ],

        assignments : [
            { event : 1, resource : 1 },
            { event : 2, resource : 2 }
        ],

        dependencies : [
            { fromEvent : 1, toEvent : 2 }
        ]
    }
});
import { Gantt } from '@bryntum/gantt-thin';
import './style.css';

const gantt = new Gantt({
    appendTo  : 'app',
    startDate : new Date(2022, 0, 1),
    endDate   : new Date(2022, 0, 10),
    columns   : [
        { type : 'name', width : 160 }
    ],
    project : {

        tasks : [
            {
                id       : 1,
                name     : 'Write docs',
                expanded : true,
                children : [
                    { id : 2, name : 'Proof-read docs', startDate : '2022-01-02', endDate : '2022-01-09' },
                    { id : 3, name : 'Release docs', startDate : '2022-01-09', endDate : '2022-01-10' }
                ]
            }
        ],

        dependencies : [
            { fromTask : 2, toTask : 3 }
        ]
    }
});
import { Calendar } from '@byntum/calendar-thin';

const calendar = new Calendar({

    appendTo : 'app',

    resources : [
        {
            id         : 1,
            name       : 'Default Calendar',
            eventColor : 'green'
        }
    ],
    events : [
        {
            id         : 1,
            name       : 'Meeting',
            startDate  : '2022-01-01T10:00:00',
            endDate    : '2022-01-01T11:00:00',
            resourceId : 1
        }
    ]
});
import { TaskBoard } from '@bryntum/taskboard-thin';
import './style.css';

const taskBoard = new TaskBoard({
    appendTo    : 'app',
    columnField : 'status',
    columns     : [
        'todo',
        'doing',
        'done'
    ],
    project : {
        tasks : [
            { id : 1,  name : 'Design landing page', status : 'doing', description : 'Creating layout for the new landing page' },
            { id : 2,  name : 'Set up database schema', status : 'todo', description : 'Define tables and relationships for user data' },
            { id : 3,  name : 'Write API documentation', status : 'done', description : 'Document the REST endpoints for the project' },
            { id : 4,  name : 'Create login screen', status : 'doing', description : 'Implement authentication UI with validation' },
            { id : 5,  name : 'Integrate payment gateway', status : 'todo', description : 'Connect Stripe API to the backend' },
            { id : 6,  name : 'Fix navigation bugs', status : 'done', description : 'Resolve reported issues with navbar links' },
            { id : 7,  name : 'Build notification system', status : 'doing', description : 'Real-time push notifications for events' },
            { id : 8,  name : 'Add unit tests', status : 'todo', description : 'Write tests for services and components' },
            { id : 9,  name : 'Optimize image loading', status : 'done', description : 'Implement lazy loading for large images' },
            { id : 10, name : 'Deploy staging server', status : 'doing', description : 'Set up CI/CD pipeline for staging environment' },
            { id : 11, name : 'Create user profile page', status : 'todo', description : 'Design and implement profile management UI' },
            { id : 12, name : 'Implement role-based access control', status : 'todo', description : 'Restrict features based on user roles' },
            { id : 13, name : 'Set up error logging', status : 'todo', description : 'Integrate centralized error monitoring tool' },
            { id : 14, name : 'Improve form validation', status : 'todo', description : 'Enhance validation rules for all forms' },
            { id : 15, name : 'Add search functionality', status : 'todo', description : 'Implement search bar with filtering options' }
        ],
        resources : [
            { id : 1, name : 'Angelo' },
            { id : 2, name : 'Celia' },
            { id : 3, name : 'Dave' },
            { id : 4, name : 'Emilia' },
            { id : 5, name : 'Gloria' },
            { id : 6, name : 'Henrik' },
            { id : 7, name : 'Kate' }
        ],
        assignments : [
            { id : 1,  event : 1,  resource : 1 },
            { id : 2,  event : 2,  resource : 2 },
            { id : 3,  event : 3,  resource : 3 },
            { id : 4,  event : 4,  resource : 4 },
            { id : 5,  event : 5,  resource : 5 },
            { id : 6,  event : 6,  resource : 6 },
            { id : 7,  event : 7,  resource : 7 },
            { id : 8,  event : 8,  resource : 1 },
            { id : 9,  event : 9,  resource : 2 },
            { id : 10, event : 10, resource : 3 },
            { id : 11, event : 11, resource : 4 },
            { id : 12, event : 12, resource : 5 },
            { id : 13, event : 1,  resource : 5 },
            { id : 14, event : 2,  resource : 5 },
            { id : 15, event : 3,  resource : 5 },
            { id : 16, event : 4,  resource : 5 },
            { id : 17, event : 6,  resource : 5 },
            { id : 18, event : 7,  resource : 5 }
        ]
    }
});

Non-npm packages

If you're not using npm, you can use module or UMD bundles.

Thin module bundle

Similar to npm packages, thin module bundles contain code for one specific product, which means that it has a much smaller size, but you have to use multiple bundles to get anything working (Grid for example has to pull in the Core bundle to work). Here's an example:

// Import 3 classes separately from different thin bundles
import { Store } from 'core.module.thin.js';
import { Grid } from 'grid.module.thin.js';
import { Calendar } from 'calendar.module.thin.js';

UMD bundle

The umd bundle (scheduler.umd.js importable as a good old script tag, exposes all classes globally) is to be considered legacy. Using it is not something we recommend unless your environment prevents you from using a more modern bundle. It will not allow you to combine multiple products very well. Below you find a snippet here for completeness:

<!-- Script tag in your html file -->
<script src="scheduler.umd.js"></script>
// No imports needed, classes are exposed to window.bryntum.scheduler
const { Store, Grid, Calendar } = window.bryntum.scheduler;

Combining products

You can combine multiple products and have them on the same page. For example, if you want to combine Grid and Scheduler, you can have them like the following:

import { Grid } from "@bryntum/grid-thin";
import { Scheduler } from "@bryntum/scheduler-thin";
import "./style.css"; // import styles

const grid = new Grid({
  appendTo: "app",
  columns: [
    { field: "name", text: "Name", width: 200 },
    { field: "city", text: "City", flex: 1 },
  ],
  data: [
    { name: "Dan Stevenson", city: "Los Angeles" },
    { name: "Talisha Babin", city: "Paris" },
  ],
});

const scheduler = new Scheduler({
  appendTo: "app",
  startDate: new Date(2022, 0, 1),
  endDate: new Date(2022, 0, 10),
  columns: [{ text: "Name", field: "name", width: 160 }],
  resources: [
    { id: 1, name: "Dan Stevenson" },
    { id: 2, name: "Talisha Babin" },
  ],
  events: [
    { resourceId: 1, startDate: "2022-01-01", endDate: "2022-01-10" },
    { resourceId: 2, startDate: "2022-01-02", endDate: "2022-01-09" },
  ],
});

Contents

v7.3.0

Combining multiple Bryntum products

Thin packages overview

Bryntum's products share the same data model and can be combined to provide different views of the underlying data.

When combining multiple Bryntum products in a single application using Vue, you should use thin npm packages. This avoids runtime errors and also reduces the amount of code and CSS that has to be downloaded.

The main difference between thin packages and regular packages is that thin only contain product specific code and styling, while regular contain code and styling for all underlying products (for example Scheduler includes Scheduler + Grid + Core). Thin packages are valid for building a single product application.

It is not possible to import several regular (non-thin) Bryntum npm packages like @bryntum/grid and @bryntum/calendar in one application. Doing this will lead to a runtime console error:
The Bryntum Calendar bundle was loaded multiple times by the application.
Do not mix regular (e.g., @bryntum/calendar) and thin (e.g., @bryntum/calendar-thin) packages in the same project. If using thin packages, remove regular ones and follow this guide to install all required dependencies.

Thin packages list

Bryntum's npm repository contains thin packages for combining multiple Bryntum products in one application.

Thin limited trial library packages:

Package Purpose
@bryntum/core-thin-trial Bryntum Core data and UI trial components package
@bryntum/grid-thin-trial Bryntum Grid trial components package
@bryntum/scheduler-thin-trial Bryntum Scheduler trial components package
@bryntum/schedulerpro-thin-trial Bryntum Scheduler Pro trial components package
@bryntum/gantt-thin-trial Bryntum Gantt trial components package
@bryntum/calendar-thin-trial Bryntum Calendar trial components package
@bryntum/taskboard-thin-trial Bryntum TaskBoard trial components package
@bryntum/engine-thin-trial Bryntum Scheduling engine trial components package
To use framework wrappers, trial packages listed above require aliasing the @bryntum/*-thin-trial package as @bryntum/*-thin during installation, as shown below. Once installed, the provided app code samples can be used without modification

Example for @bryntum/calendar-thin-trial package:

npm install @bryntum/calendar-thin@npm:@bryntum/calendar-thin-trial@7.3.0

Alternatively, you can directly add entries to the "dependencies" section of the package.json project file as follows:

"dependencies": {
  "@bryntum/calendar-thin": "npm:@bryntum/calendar-thin-trial@7.3.0",
}

Thin licensed library packages:

Package Purpose
@bryntum/core-thin Bryntum Core data and UI components package
@bryntum/grid-thin Bryntum Grid components package
@bryntum/scheduler-thin Bryntum Scheduler components package
@bryntum/schedulerpro-thin Bryntum Scheduler Pro components package
@bryntum/gantt-thin Bryntum Gantt components package
@bryntum/calendar-thin Bryntum Calendar components package
@bryntum/taskboard-thin Bryntum TaskBoard components package
@bryntum/engine-thin Bryntum Scheduling engine components package

Thin Vue 3 wrapper packages:

Package Purpose
@bryntum/core-vue-3-thin Bryntum Core UI widgets Vue 3 wrappers package
@bryntum/grid-vue-3-thin Bryntum Grid Vue 3 wrapper package
@bryntum/scheduler-vue-3-thin Bryntum Scheduler Vue 3 wrapper package
@bryntum/schedulerpro-vue-3-thin Bryntum Scheduler Pro Vue 3 wrapper package
@bryntum/gantt-vue-3-thin Bryntum Gantt Vue 3 wrapper package
@bryntum/calendar-vue-3-thin Bryntum Calendar Vue 3 wrapper package
@bryntum/taskboard-vue-3-thin Bryntum TaskBoard Vue 3 wrapper package

Package dependencies

Each package contains code related to the specific product only and requires installing a dependency packages for all underlying products. This is not done automatically to give you full control over the installed packages.

List of required dependencies used in package.json for Vue 3 application:

@bryntum/core-vue-3-thin is listed among the available framework wrapper packages, but you only need to install it if you use Bryntum Core UI widgets in your app (e.g., BryntumButton, BryntumCombo etc.). It's not needed otherwise.
However, you should always install all API packages as they are required for the proper functioning.

Please note that you need an active license for each product to use it in the UI.
GridSchedulerScheduler ProGanttCalendarTaskBoard
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-vue-3-thin": "7.3.0",
    "@bryntum/grid-vue-3-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-vue-3-thin": "7.3.0",
    "@bryntum/scheduler-vue-3-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/schedulerpro-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-vue-3-thin": "7.3.0",
    "@bryntum/schedulerpro-vue-3-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/schedulerpro-thin": "7.3.0",
    "@bryntum/gantt-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-vue-3-thin": "7.3.0",
    "@bryntum/gantt-vue-3-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/calendar-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-vue-3-thin": "7.3.0",
    "@bryntum/calendar-vue-3-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/taskboard-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-vue-3-thin": "7.3.0",
    "@bryntum/taskboard-vue-3-thin": "7.3.0"
  }
}

Product configuration

Importing product configuration for Vue 3 application app.config.tsx:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import { BryntumGridProps } from '@bryntum/grid-vue-3-thin';

const gridProps : BryntumGridProps = {
    // Grid configuration
};
import { BryntumSchedulerProps } from '@bryntum/scheduler-vue-3-thin';

const schedulerProps : BryntumSchedulerProps = {
    // Scheduler configuration
};
import { BryntumSchedulerProProps } from '@bryntum/schedulerpro-vue-3-thin';

const schedulerProProps : BryntumSchedulerProProps = {
    // Scheduler Pro configuration
};
import { BryntumGanttProps } from '@bryntum/gantt-vue-3-thin';

const ganttProps : BryntumGanttProps = {
    // Gantt configuration
};
import { BryntumCalendarProps } from '@bryntum/calendar-vue-3-thin';

const calendarProps : BryntumCalendarProps = {
    // Calendar configuration
};
import { BryntumTaskBoardProps } from '@bryntum/taskboard-vue-3-thin';

const taskBoardProps : BryntumTaskBoardProps = {
    // TaskBoard configuration
};

Product localization

For a complete localization information please check localization guide.

Localization can be done using these two methods:

Using source code

Import product locale from a thin package in your application

Example for German De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import '@bryntum/grid-thin/lib/localization/De.js'
import '@bryntum/scheduler-thin/lib/localization/De.js'
import '@bryntum/schedulerpro-thin/lib/localization/De.js'
import '@bryntum/gantt-thin/lib/localization/De.js'
import '@bryntum/calendar-thin/lib/localization/De.js'
import '@bryntum/taskboard-thin/lib/localization/De.js'

Using prebuilt full locale

Import full UMD locale from the installed @bryntum package.

Example for De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import '@bryntum/grid-thin/lib/locales/grid.locale.De.js'
import '@bryntum/scheduler-thin/lib/locales/scheduler.locale.De.js'
import '@bryntum/schedulerpro-thin/lib/locales/schedulerpro.locale.De.js'
import '@bryntum/gantt-thin/lib/locales/gantt.locale.De.js'
import '@bryntum/calendar-thin/lib/locales/calendar.locale.De.js'
import '@bryntum/taskboard-thin/lib/locales/taskboard.locale.De.js'

Full locale can also be added to the index.html file of your application. You need to copy locales from the installed @bryntum package to a folder located at PATH_TO_LOCALE first, and then add this script to the application's home page.

Example for Grid product and German De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
<script src="PATH_TO_LOCALE/locales/grid.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/scheduler.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/schedulerpro.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/gantt.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/calendar.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/taskboard.locale.De.js"></script>

Product styling

List of required styles for Vue application App.scss:

GridSchedulerScheduler ProGanttCalendarTaskBoard
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/schedulerpro-thin/schedulerpro.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/schedulerpro-thin/schedulerpro.css';
@import '@bryntum/gantt-thin/gantt.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/calendar-thin/calendar.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/taskboard-thin/taskboard.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';

Product template

Example of configuring product template for Vue application App.vue:

GridSchedulerScheduler ProGanttCalendarTaskBoard
<script setup>
import { createApp, ref } from 'vue';

import { BryntumGrid } from '@bryntum/grid-vue-3-thin';
import { gridProps } from './AppConfig';

import './App.scss';

createApp({
});
</script>

<template>
    <bryntum-grid
        v-bind=gridProps
    />
</template>

<style lang="scss">
</style>
<script setup>
import { createApp, ref } from 'vue';

import { BryntumScheduler } from '@bryntum/scheduler-vue-3-thin';
import { schedulerProps } from './AppConfig';

import './App.scss';

createApp({
});
</script>

<template>
    <bryntum-scheduler
        v-bind=schedulerProps
    />
</template>

<style lang="scss">
</style>
<script setup>
import { createApp, ref } from 'vue';

import { BryntumSchedulerPro, BryntumSchedulerProProjectModel } from '@bryntum/schedulerpro-vue-3-thin';
import { schedulerProProjectProps, schedulerProProps } from './configs/schedulerrpo';

import './App.scss';

const schedulerProProject = ref(null);

createApp({
    setup() {
        return {
            schedulerProProject
        };
    }
});
</script>

<template>
    <bryntum-scheduler-pro-project-model
        ref="schedulerProProject"
        v-bind=schedulerProProjectProps
    />
    <bryntum-scheduler-pro
        :project="schedulerProProject"
        v-bind="schedulerProProps"
    />
</template>

<style lang="scss">
</style>

Using bryntum-scheduler-pro-project-model is not obligatory, you can also configure the project by supplying a configuration object to the project prop, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

<script setup>
import { createApp, ref } from 'vue';

import { BryntumGantt, BryntumGanttProjectModel } from '@bryntum/gantt-vue-3-thin';
import { ganttProps, ganttProjectProps } from './AppConfig';

import './App.scss';

const ganttProject = ref(null);

createApp({
    setup() {
        return {
            ganttProject
        };
    }
});
</script>

<template>
    <bryntum-gantt-project-model
        ref="ganttProject"
        v-bind=ganttProjectProps
    />
    <bryntum-gantt
        :project="ganttProject"
        v-bind="ganttProps"
    />
</template>

<style lang="scss">
</style>

Using bryntum-gantt-pro-project-model is not obligatory, you can also configure the project by supplying a configuration object to the project prop, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

<script setup>
import { createApp, ref } from 'vue';

import { BryntumCalendar } from '@bryntum/calendar-vue-3-thin';
import { calendarProps } from './AppConfig';

import './App.scss';

createApp({
});
</script>

<template>
    <bryntum-calendar
        v-bind=calendarProps
    />
</template>

<style lang="scss">
</style>
<script setup>
import { createApp, ref } from 'vue';

import { BryntumTaskBoard, BryntumTaskBoardProjectModel } from '@bryntum/taskboard-vue-3-thin';
import { taskBoardProjectProps,taskBoardProps } from './AppConfig';

import './App.scss';

const taskBoardProject = ref(null);

createApp({
    setup() {
        return {
            taskBoardProject
        };
    }
});
</script>

<template>
    <bryntum-task-board-project-model
        ref="taskBoardProject"
        v-bind=taskBoardProjectProps
    />
    <bryntum-task-board
        :project="taskBoardProject"
        v-bind=taskBoardProps
    />

</template>

<style lang="scss">
</style>

Using bryntum-task-board-pro-project-model is not obligatory, you can also configure the project by supplying a configuration object to the project prop, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

Technical demo

Technical demo showing all products in one application can be seen here. You may download source there clicking on Download header icon.

Contents

v7.3.0

Combining multiple Bryntum products

Thin packages overview

Bryntum's products share the same data model and can be combined to provide different views of the underlying data.

When combining multiple Bryntum products in a single application using React, you should use thin npm packages. This avoids runtime errors and also reduces the amount of code and CSS that has to be downloaded.

The main difference between thin packages and regular packages is that thin only contain product specific code and styling, while regular contain code and styling for all underlying products (for example Scheduler includes Scheduler + Grid + Core). Thin packages are valid for building a single product application.

It is not possible to import several regular (non-thin) Bryntum npm packages like @bryntum/grid and @bryntum/calendar in one application. Doing this will lead to a runtime console error:
The Bryntum Calendar bundle was loaded multiple times by the application.
Do not mix regular (e.g., @bryntum/calendar) and thin (e.g., @bryntum/calendar-thin) packages in the same project. If using thin packages, remove regular ones and follow this guide to install all required dependencies.

Thin packages list

Bryntum's npm repository contains thin packages for combining multiple Bryntum products in one application.

Thin limited trial library packages:

Package Purpose
@bryntum/core-thin-trial Bryntum Core data and UI trial components package
@bryntum/grid-thin-trial Bryntum Grid trial components package
@bryntum/scheduler-thin-trial Bryntum Scheduler trial components package
@bryntum/schedulerpro-thin-trial Bryntum Scheduler Pro trial components package
@bryntum/gantt-thin-trial Bryntum Gantt trial components package
@bryntum/calendar-thin-trial Bryntum Calendar trial components package
@bryntum/taskboard-thin-trial Bryntum TaskBoard trial components package
@bryntum/engine-thin-trial Bryntum Scheduling engine trial components package
To use framework wrappers, trial packages listed above require aliasing the @bryntum/*-thin-trial package as @bryntum/*-thin during installation, as shown below. Once installed, the provided app code samples can be used without modification

Example for @bryntum/calendar-thin-trial package:

npm install @bryntum/calendar-thin@npm:@bryntum/calendar-thin-trial@7.3.0

Alternatively, you can directly add entries to the "dependencies" section of the package.json project file as follows:

"dependencies": {
  "@bryntum/calendar-thin": "npm:@bryntum/calendar-thin-trial@7.3.0",
}

Thin licensed library packages:

Package Purpose
@bryntum/core-thin Bryntum Core data and UI components package
@bryntum/grid-thin Bryntum Grid components package
@bryntum/scheduler-thin Bryntum Scheduler components package
@bryntum/schedulerpro-thin Bryntum Scheduler Pro components package
@bryntum/gantt-thin Bryntum Gantt components package
@bryntum/calendar-thin Bryntum Calendar components package
@bryntum/taskboard-thin Bryntum TaskBoard components package
@bryntum/engine-thin Bryntum Scheduling engine components package

Thin React wrapper packages:

Package Purpose
@bryntum/core-react-thin Bryntum Core UI widgets React wrappers package
@bryntum/grid-react-thin Bryntum Grid React wrapper package
@bryntum/scheduler-react-thin Bryntum Scheduler React wrapper package
@bryntum/schedulerpro-react-thin Bryntum Scheduler Pro React wrapper package
@bryntum/gantt-react-thin Bryntum Gantt React wrapper package
@bryntum/calendar-react-thin Bryntum Calendar React wrapper package
@bryntum/taskboard-react-thin Bryntum TaskBoard React wrapper package

Package dependencies

Each package contains code related to the specific product only and requires installing a dependency packages for all underlying products. This is not done automatically to give you full control over the installed packages.

List of required dependencies used in package.json for React application:

@bryntum/core-react-thin is listed among the available framework wrapper packages, but you only need to install it if you use Bryntum Core UI widgets in your app (e.g., BryntumButton, BryntumCombo etc.). It's not needed otherwise.
However, you should always install all API packages as they are required for the proper functioning.

Please note that you need an active license for each product to use it in the UI.
GridSchedulerScheduler ProGanttCalendarTaskBoard
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-react-thin": "7.3.0",
    "@bryntum/grid-react-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-react-thin": "7.3.0",
    "@bryntum/scheduler-react-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/schedulerpro-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-react-thin": "7.3.0",
    "@bryntum/schedulerpro-react-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/schedulerpro-thin": "7.3.0",
    "@bryntum/gantt-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-react-thin": "7.3.0",
    "@bryntum/gantt-react-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/calendar-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-react-thin": "7.3.0",
    "@bryntum/calendar-react-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/taskboard-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-react-thin": "7.3.0",
    "@bryntum/taskboard-react-thin": "7.3.0"
  }
}

Product configuration

Importing product configuration for React application app.config.tsx:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import { BryntumGridProps } from '@bryntum/grid-react-thin';

const gridProps : BryntumGridProps = {
    // Grid configuration
};
import { BryntumSchedulerProps } from '@bryntum/scheduler-react-thin';

const schedulerProps : BryntumSchedulerProps = {
    // Scheduler configuration
};
import { BryntumSchedulerProProps } from '@bryntum/schedulerpro-react-thin';

const schedulerProProps : BryntumSchedulerProProps = {
    // Scheduler Pro configuration
};
import { BryntumGanttProps } from '@bryntum/gantt-react-thin';

const ganttProps : BryntumGanttProps = {
    // Gantt configuration
};
import { BryntumCalendarProps } from '@bryntum/calendar-react-thin';

const calendarProps : BryntumCalendarProps = {
    // Calendar configuration
};
import { BryntumTaskBoardProps } from '@bryntum/taskboard-react-thin';

const taskBoardProps : BryntumTaskBoardProps = {
    // TaskBoard configuration
};

Product styling

List of required styles for React application App.scss:

GridSchedulerScheduler ProGanttCalendarTaskBoard
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/schedulerpro-thin/schedulerpro.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/schedulerpro-thin/schedulerpro.css';
@import '@bryntum/gantt-thin/gantt.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/calendar-thin/calendar.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/taskboard-thin/taskboard.css';
/* Theme */
@import '@bryntum/core-thin/svalbard-light.css';

Product localization

For a complete localization information please check localization guide.

Localization can be done using these two methods:

Using source code

Import product locale from a thin package in your application

Example for German De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import '@bryntum/grid-thin/lib/localization/De.js'
import '@bryntum/scheduler-thin/lib/localization/De.js'
import '@bryntum/schedulerpro-thin/lib/localization/De.js'
import '@bryntum/gantt-thin/lib/localization/De.js'
import '@bryntum/calendar-thin/lib/localization/De.js'
import '@bryntum/taskboard-thin/lib/localization/De.js'

Using prebuilt full locale

Import full UMD locale from the installed @bryntum package.

Example for De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import '@bryntum/grid-thin/lib/locales/grid.locale.De.js'
import '@bryntum/scheduler-thin/lib/locales/scheduler.locale.De.js'
import '@bryntum/schedulerpro-thin/lib/locales/schedulerpro.locale.De.js'
import '@bryntum/gantt-thin/lib/locales/gantt.locale.De.js'
import '@bryntum/calendar-thin/lib/locales/calendar.locale.De.js'
import '@bryntum/taskboard-thin/lib/locales/taskboard.locale.De.js'

Full locale can also be added to the index.html file of your application. You need to copy locales from the installed @bryntum package to a folder located at PATH_TO_LOCALE first, and then add this script to the application's home page.

Example for Grid product and German De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
<script src="PATH_TO_LOCALE/locales/grid.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/scheduler.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/schedulerpro.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/gantt.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/calendar.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/taskboard.locale.De.js"></script>

Product template

Example of configuring product template for React application App.tsx:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import { BryntumGrid } from '@bryntum/grid-react';
import { gridProps } from './GridConfig';
import './App.scss';

function App() {

    return (
        <BryntumGrid
            {...gridProps}
        />
    );
}

export default App;
import React, { FunctionComponent, useRef } from 'react';
import { BryntumScheduler } from '@bryntum/scheduler-react-thin';
import { schedulerProps } from './SchedulerConfig';
import './App.scss';

const App: FunctionComponent = () => {

    const scheduler = useRef<BryntumScheduler>(null);

    return (
        <BryntumScheduler
            ref = {scheduler}
            {...schedulerProps}
        />
    );
};

export default App;
import React, { FunctionComponent, useRef } from 'react';
import { BryntumSchedulerPro } from '@bryntum/schedulerpro-react';
import { schedulerproProps } from './schedulerProConfig';
import './App.scss';

const App: FunctionComponent = () => {

    const schedulerpro = useRef<BryntumSchedulerPro>(null);

    return (
        <BryntumSchedulerPro
            ref = {schedulerpro}
            {...schedulerproProps}
        />
    );
};

export default App;

Using BryntumSchedulerProProjectModel is not obligatory, you can also configure the project by supplying a configuration object to the project prop, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

import { FunctionComponent, useRef } from 'react';
import { BryntumGantt } from '@bryntum/gantt-react';
import { ganttProps } from './ganttConfig';
import './App.scss';

const App: FunctionComponent = () => {
  const gantt = useRef<BryntumGantt>(null);

  return <BryntumGantt ref={gantt} {...ganttProps} />;
};

export default App;

Using BryntumGanttProjectModel is not obligatory, you can also configure the project by supplying a configuration object to the project prop, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

import { FunctionComponent, useRef } from 'react';
import { BryntumCalendar } from '@bryntum/calendar-react';
import { calendarProps } from './CalendarConfig';
import './App.scss';

const App: FunctionComponent = () => {

    const calendar = useRef<BryntumCalendar>(null);

    return (
        <BryntumCalendar
            ref = {calendar}
            {...calendarProps}
        />
    );
};

export default App;
import { FunctionComponent, useRef } from 'react';
import { BryntumTaskBoard } from '@bryntum/taskboard-react-thin';
import { taskboardProps } from './TaskBoardConfig';
import './App.scss';

const App: FunctionComponent = () => {

    const taskboard = useRef<BryntumTaskBoard>(null);

    return (
        <BryntumTaskBoard
            ref = {taskboard}
            {...taskboardProps}
        />
    );
};

export default App;

Using BryntumTaskBoardProjectModel is not obligatory, you can also configure the project by supplying a configuration object to the project prop, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

Technical demo

Technical demo showing all products in one application can be seen here. You may download source there clicking on Download header icon.

Contents

v7.3.0

Combining multiple Bryntum products

Thin packages overview

Bryntum's products share the same data model and can be combined to provide different views of the underlying data.

When combining multiple Bryntum products in a single application using Angular, you should use thin npm packages. This avoids runtime errors and also reduces the amount of code and CSS that has to be downloaded.

The main difference between thin packages and regular packages is that thin only contain product specific code and styling, while regular contain code and styling for all underlying products (for example Scheduler includes Scheduler + Grid + Core). Thin packages are valid for building a single product application.

It is not possible to import several regular (non-thin) Bryntum npm packages like @bryntum/grid and @bryntum/calendar in one application. Doing this will lead to a runtime console error:
The Bryntum Calendar bundle was loaded multiple times by the application.
Do not mix regular (e.g., @bryntum/calendar) and thin (e.g., @bryntum/calendar-thin) packages in the same project. If using thin packages, remove regular ones and follow this guide to install all required dependencies.

Thin packages list

Bryntum's npm repository contains thin packages for combining multiple Bryntum products in one application.

Thin limited trial library packages:

Package Purpose
@bryntum/core-thin-trial Bryntum Core data and UI trial components package
@bryntum/grid-thin-trial Bryntum Grid trial components package
@bryntum/scheduler-thin-trial Bryntum Scheduler trial components package
@bryntum/schedulerpro-thin-trial Bryntum Scheduler Pro trial components package
@bryntum/gantt-thin-trial Bryntum Gantt trial components package
@bryntum/calendar-thin-trial Bryntum Calendar trial components package
@bryntum/taskboard-thin-trial Bryntum TaskBoard trial components package
@bryntum/engine-thin-trial Bryntum Scheduling engine trial components package
To use framework wrappers, trial packages listed above require aliasing the @bryntum/*-thin-trial package as @bryntum/*-thin during installation, as shown below. Once installed, the provided app code samples can be used without modification

Example for @bryntum/calendar-thin-trial package:

npm install @bryntum/calendar-thin@npm:@bryntum/calendar-thin-trial@7.3.0

Alternatively, you can directly add entries to the "dependencies" section of the package.json project file as follows:

"dependencies": {
  "@bryntum/calendar-thin": "npm:@bryntum/calendar-thin-trial@7.3.0",
}

Thin licensed library packages:

Package Purpose
@bryntum/core-thin Bryntum Core data and UI components package
@bryntum/grid-thin Bryntum Grid components package
@bryntum/scheduler-thin Bryntum Scheduler components package
@bryntum/schedulerpro-thin Bryntum Scheduler Pro components package
@bryntum/gantt-thin Bryntum Gantt components package
@bryntum/calendar-thin Bryntum Calendar components package
@bryntum/taskboard-thin Bryntum TaskBoard components package
@bryntum/engine-thin Bryntum Scheduling engine components package

Thin Angular wrapper packages:

Package Purpose
@bryntum/core-angular-thin Bryntum Core UI widgets Angular wrappers package
@bryntum/grid-angular-thin Bryntum Grid Angular wrapper package
@bryntum/scheduler-angular-thin Bryntum Scheduler Angular wrapper package
@bryntum/schedulerpro-angular-thin Bryntum Scheduler Pro Angular wrapper package
@bryntum/gantt-angular-thin Bryntum Gantt Angular wrapper package
@bryntum/calendar-angular-thin Bryntum Calendar Angular wrapper package
@bryntum/taskboard-angular-thin Bryntum TaskBoard Angular wrapper package

Package dependencies

Each package contains code related to the specific product only and requires installing a dependency packages for all underlying products. This is not done automatically to give you full control over the installed packages.

List of required dependencies used in package.json for Angular application:

@bryntum/core-angular-thin is listed among the available framework wrapper packages, but you only need to install it if you use Bryntum Core UI widgets in your app (e.g., BryntumButton, BryntumCombo etc.). It's not needed otherwise.
However, you should always install all API packages as they are required for the proper functioning.

Please note that you need an active license for each product to use it in the UI.
GridSchedulerScheduler ProGanttCalendarTaskBoard
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-angular-thin": "7.3.0",
    "@bryntum/grid-angular-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-angular-thin": "7.3.0",
    "@bryntum/scheduler-angular-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/schedulerpro-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-angular-thin": "7.3.0",
    "@bryntum/schedulerpro-angular-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/schedulerpro-thin": "7.3.0",
    "@bryntum/gantt-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-angular-thin": "7.3.0",
    "@bryntum/gantt-angular-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/grid-thin": "7.3.0",
    "@bryntum/scheduler-thin": "7.3.0",
    "@bryntum/calendar-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-angular-thin": "7.3.0",
    "@bryntum/calendar-angular-thin": "7.3.0"
  }
}
API packages:
{
  "dependencies": {
    "@bryntum/core-thin": "7.3.0",
    "@bryntum/engine-thin": "7.3.0",
    "@bryntum/taskboard-thin": "7.3.0"
  }
}
Framework wrapper packages:
{
  "dependencies": {
    "@bryntum/core-angular-thin": "7.3.0",
    "@bryntum/taskboard-angular-thin": "7.3.0"
  }
}

Modules configuration

Importing package module for Angular application app.module.ts:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import { NgModule } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { BryntumCoreModule } from '@bryntum/core-angular-thin'; import { BryntumGridModule } from '@bryntum/grid-angular-thin'; import { AppComponent } from './app'; @NgModule({ declarations : [ AppComponent ], imports : [ BrowserModule, BryntumCoreModule, BryntumGridModule ], providers : [], bootstrap : [AppComponent] }) export class AppModule {}
import { NgModule } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { BryntumCoreModule } from '@bryntum/core-angular-thin'; import { BryntumGridModule } from '@bryntum/grid-angular-thin'; import { BryntumSchedulerModule } from '@bryntum/scheduler-angular-thin'; import { AppComponent } from './app'; @NgModule({ declarations : [ AppComponent ], imports : [ BrowserModule, BryntumCoreModule, BryntumGridModule, BryntumSchedulerModule ], providers : [], bootstrap : [AppComponent] }) export class AppModule {}
import { NgModule } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { BryntumCoreModule } from '@bryntum/core-angular-thin'; import { BryntumGridModule } from '@bryntum/grid-angular-thin'; import { BryntumSchedulerModule } from '@bryntum/scheduler-angular-thin'; import { BryntumSchedulerProModule } from '@bryntum/schedulerpro-angular-thin'; import { AppComponent } from './app'; @NgModule({ declarations : [ AppComponent ], imports : [ BrowserModule, BryntumCoreModule, BryntumGridModule, BryntumSchedulerModule, BryntumSchedulerProModule ], providers : [], bootstrap : [AppComponent] }) export class AppModule {}
import { NgModule } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { BryntumCoreModule } from '@bryntum/core-angular-thin'; import { BryntumGridModule } from '@bryntum/grid-angular-thin'; import { BryntumSchedulerModule } from '@bryntum/scheduler-angular-thin'; import { BryntumSchedulerProModule } from '@bryntum/schedulerpro-angular-thin'; import { BryntumGanttModule } from '@bryntum/gantt-angular-thin'; import { AppComponent } from './app'; @NgModule({ declarations : [ AppComponent ], imports : [ BrowserModule, BryntumCoreModule, BryntumGridModule, BryntumSchedulerModule, BryntumSchedulerProModule, BryntumGanttModule ], providers : [], bootstrap : [AppComponent] }) export class AppModule {}
import { NgModule } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { BryntumCoreModule } from '@bryntum/core-angular-thin'; import { BryntumGridModule } from '@bryntum/grid-angular-thin'; import { BryntumSchedulerModule } from '@bryntum/scheduler-angular-thin'; import { BryntumCalendarModule } from '@bryntum/calendar-angular-thin'; import { AppComponent } from './app'; @NgModule({ declarations : [ AppComponent ], imports : [ BrowserModule, BryntumCoreModule, BryntumGridModule, BryntumSchedulerModule, BryntumCalendarModule ], providers : [], bootstrap : [AppComponent] }) export class AppModule {}
import { NgModule } from '@angular/core'; import { BrowserModule } from '@angular/platform-browser'; import { BryntumCoreModule } from '@bryntum/core-angular-thin'; import { BryntumTaskBoardModule } from '@bryntum/taskboard-angular-thin'; import { AppComponent } from './app'; @NgModule({ declarations : [ AppComponent ], imports : [ BrowserModule, BryntumCoreModule, BryntumTaskBoardModule ], providers : [], bootstrap : [AppComponent] }) export class AppModule {}

Product localization

For a complete localization information please check localization guide.

Localization can be done using these two methods:

Using source code

Import product locale from a thin package in your application

Example for German De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import '@bryntum/grid-thin/lib/localization/De.js'
import '@bryntum/scheduler-thin/lib/localization/De.js'
import '@bryntum/schedulerpro-thin/lib/localization/De.js'
import '@bryntum/gantt-thin/lib/localization/De.js'
import '@bryntum/calendar-thin/lib/localization/De.js'
import '@bryntum/taskboard-thin/lib/localization/De.js'

Using prebuilt full locale

Import full UMD locale from the installed @bryntum package.

Example for De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import '@bryntum/grid-thin/lib/locales/grid.locale.De.js'
import '@bryntum/scheduler-thin/lib/locales/scheduler.locale.De.js'
import '@bryntum/schedulerpro-thin/lib/locales/schedulerpro.locale.De.js'
import '@bryntum/gantt-thin/lib/locales/gantt.locale.De.js'
import '@bryntum/calendar-thin/lib/locales/calendar.locale.De.js'
import '@bryntum/taskboard-thin/lib/locales/taskboard.locale.De.js'

Full locale can also be added to the index.html file of your application. You need to copy locales from the installed @bryntum package to a folder located at PATH_TO_LOCALE first, and then add this script to the application's home page.

Example for Grid product and German De locale:

GridSchedulerScheduler ProGanttCalendarTaskBoard
<script src="PATH_TO_LOCALE/locales/grid.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/scheduler.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/schedulerpro.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/gantt.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/calendar.locale.De.js"></script>
<script src="PATH_TO_LOCALE/locales/taskboard.locale.De.js"></script>

Product configuration

Importing product configuration for Angular application app.config.tsx:

GridSchedulerScheduler ProGanttCalendarTaskBoard
import { BryntumGridProps } from '@bryntum/grid-angular-thin';

const gridProps : BryntumGridProps = {
    // Grid configuration
};
import { BryntumSchedulerProps } from '@bryntum/scheduler-angular-thin';

const schedulerProps : BryntumSchedulerProps = {
    // Scheduler configuration
};
import { BryntumSchedulerProProps } from '@bryntum/schedulerpro-angular-thin';

const schedulerProProps : BryntumSchedulerProProps = {
    // Scheduler Pro configuration
};
import { BryntumGanttProps } from '@bryntum/gantt-angular-thin';

const ganttProps : BryntumGanttProps = {
    // Gantt configuration
};
import { BryntumCalendarProps } from '@bryntum/calendar-angular-thin';

const calendarProps : BryntumCalendarProps = {
    // Calendar configuration
};
import { BryntumTaskBoardProps } from '@bryntum/taskboard-angular-thin';

const taskBoardProps : BryntumTaskBoardProps = {
    // TaskBoard configuration
};

Product styling

List of required styles for Angular application app.component.scss:

GridSchedulerScheduler ProGanttCalendarTaskBoard
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
/* Theme */
@import '@bryntum/core-thin/material3-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
/* Theme */
@import '@bryntum/core-thin/material3-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/schedulerpro-thin/schedulerpro.css';
/* Theme */
@import '@bryntum/core-thin/material3-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/schedulerpro-thin/schedulerpro.css';
@import '@bryntum/gantt-thin/gantt.css';
/* Theme */
@import '@bryntum/core-thin/material3-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/grid-thin/grid.css';
@import '@bryntum/scheduler-thin/scheduler.css';
@import '@bryntum/calendar-thin/calendar.css';
/* Theme */
@import '@bryntum/core-thin/material3-light.css';
SCSS/CSS:
/* FontAwesome is used for icons */
@import '@bryntum/core-thin/fontawesome/css/fontawesome.css';
@import "@bryntum/core-thin/fontawesome/css/solid.css";
/* Structural CSS */
@import '@bryntum/core-thin/core.css';
@import '@bryntum/taskboard-thin/taskboard.css';
/* Theme */
@import '@bryntum/core-thin/material3-light.css';

If you import styles from *.css files, please ensure that fonts from @bryntum/core-thin are copied to assets.

Add this to angular.json file:

"assets": [
  {
    "glob": "**/*",
    "input": "node_modules/@bryntum/core-thin/fonts",
    "output": "assets/fonts"
  },
  ...
],

These setup is also required for styling.

Add to app.component.scss before importing component styles:

// This is required to setup font locations for Angular SCSS preprocessor
$fa-font-path  : '../../fonts';
$roboto-font-path : '../../../fonts';

Product template

Example of configuring product template for Angular application app.component.html:

GridSchedulerScheduler ProGanttCalendarTaskBoard
<bryntum-grid
    #grid
    ...
></bryntum-grid>
<bryntum-scheduler
    #scheduler
    ...
></bryntum-scheduler>
<bryntum-scheduler-pro-project-model
    #schedulerProProject
    ...
></bryntum-scheduler-pro-project-model>
<bryntum-scheduler-pro
    #schedulerpro
    [project]="schedulerProProject"
    ...
></bryntum-scheduler-pro>

Using bryntum-scheduler-pro-project-model is not obligatory, you can also configure the project by supplying a configuration object to the [project] property, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

<bryntum-gantt-project-model
    #ganttProject
    ...
></bryntum-gantt-project-model>
<bryntum-gantt
    #gantt
    [project]="ganttProject!"
    ...
></bryntum-gantt>

Using bryntum-gantt-pro-project-model is not obligatory, you can also configure the project by supplying a configuration object to the [project] property, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

<bryntum-calendar
    #calendar
    ...
></bryntum-calendar>
<bryntum-task-board-project-model
    #taskBoardProject
    ...
></bryntum-task-board-project-model>
<bryntum-task-board
    #taskboard
    [project]="taskBoardProject"
    ...
></bryntum-task-board>

Using bryntum-task-board-pro-project-model is not obligatory, you can also configure the project by supplying a configuration object to the [project] property, or leave it out fully and supply data in other ways. Using the project component is only required when you want to share the full project between multiple products.

Technical demo

Technical demo showing all products in one application can be seen here. You may download source there clicking on Download header icon.

Contents